/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfrom.h"
#include "prog.h"
#include "builtin.h"

#line 1 "bi_db.m4"
/* This file is part of mailfrom filter.             -*- c -*-
   Copyright (C) 2006 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
   MA 02110-1301 USA */

#ifdef USE_DBM

#define LOOKUP_NULL_BYTE 0x1
#define LOOKUP_TEST_ONLY 0x2

static int
dbmap_lookup(eval_environ_t env, char *dbname, const char *keystr,
	     const char *defval, int flags)
{
	int rc;
	DBM_FILE db;
	DBM_DATUM key;
	DBM_DATUM contents;

	if (!defval)
		defval = "";
	if (mu_dbm_open(dbname, &db, MU_STREAM_READ, 0, NULL))
			do {
#line 40
		if (env_catch(env, mf_dbfailure) == 0)
#line 40
			return -1;
#line 40
		else
#line 40
			runtime_error(env,
#line 40
				      
#line 40
			              "mu_dbm_open(%s) failed: %s",dbname,mu_strerror(errno));
#line 40
	} while (0) 
#line 40
;

	memset(&key, 0, sizeof key);
	memset(&contents, 0, sizeof contents);
	MU_DATUM_PTR(key) = (void*) keystr;
	MU_DATUM_SIZE(key) = strlen(keystr);
	if (flags & LOOKUP_NULL_BYTE)
		MU_DATUM_SIZE(key)++;
	rc = mu_dbm_fetch(&db, key, &contents) == 0;
	debug2(10, "Looking up %s: %s", keystr, rc ? "true" : "false");
	if (flags & LOOKUP_TEST_ONLY) 
		push(env, (STKVAL)rc);
	else {
		if (!rc) {
			if (defval)
				pushs(env, (STKVAL)defval);
			else
				push(env, 0);
		} else if (((char*)MU_DATUM_PTR(contents))[MU_DATUM_SIZE(contents)-1]) {
			size_t len = MU_DATUM_SIZE(contents);
			char *s = heap_reserve(env, len + 1);
			memcpy(s, MU_DATUM_PTR(contents), len);
			s[len] = 0;
			push(env, (STKVAL) s);
		} else
			pushs(env, MU_DATUM_PTR(contents));
	}
	mu_dbm_datum_free(&contents);
	mu_dbm_close(&db);
	return rc;
}

void
#line 72
bi_dbmap(eval_environ_t env)
#line 72 "bi_db.m4"
{
#line 72
	
#line 72
char * dbname = (char *) get_arg(env, 2);
#line 72
        char * key = (char *) get_arg(env, 1);
#line 72
        long  null = (long ) get_arg(env, 0);
#line 72
        
#line 72
        adjust_stack(env, 3);
#line 72

#line 72
	if (prog_trace_option & BUILTIN_MASK_db)
#line 72
		prog_trace(env, "dbmap %s %s %lu",dbname, key, null);;
#line 72

{
	dbmap_lookup(env, dbname, key, NULL,
		     LOOKUP_TEST_ONLY | (null ? LOOKUP_NULL_BYTE : 0));
}
}

#line 80
void
#line 80
bi_dbget(eval_environ_t env)
#line 80 "bi_db.m4"
{
#line 80
	
#line 80
char * dbname = (char *) get_arg(env, 3);
#line 80
        char * key = (char *) get_arg(env, 2);
#line 80
        char * defval = (char *) get_arg(env, 1);
#line 80
        long  null = (long ) get_arg(env, 0);
#line 80
        
#line 80
        adjust_stack(env, 4);
#line 80

#line 80
	if (prog_trace_option & BUILTIN_MASK_db)
#line 80
		prog_trace(env, "dbget %s %s %s %lu",dbname, key, defval, null);;
#line 80

{
	dbmap_lookup(env, dbname, key, defval, (null ? LOOKUP_NULL_BYTE : 0));
}
}

#line 87
void
#line 87
bi_dbput(eval_environ_t env)
#line 87 "bi_db.m4"
{
#line 87
	
#line 87
char * dbname = (char *) get_arg(env, 3);
#line 87
        char * keystr = (char *) get_arg(env, 2);
#line 87
        char * value = (char *) get_arg(env, 1);
#line 87
        long  null = (long ) get_arg(env, 0);
#line 87
        
#line 87
        adjust_stack(env, 4);
#line 87

#line 87
	if (prog_trace_option & BUILTIN_MASK_db)
#line 87
		prog_trace(env, "dbput %s %s %s %lu",dbname, keystr, value, null);;
#line 87

{
	int rc;
	DBM_FILE db;
	DBM_DATUM key;
	DBM_DATUM contents;
	
	if (mu_dbm_open(dbname, &db, MU_STREAM_RDWR, 0640, NULL))
			do {
#line 98
		if (env_catch(env, mf_dbfailure) == 0)
#line 98
			return ;
#line 98
		else
#line 98
			runtime_error(env,
#line 98
				                                                  "dbput: " "mu_dbm_open(%s) failed: %s",dbname,mu_strerror(errno));
#line 98
	} while (0) 
#line 98
;
	memset(&key, 0, sizeof key);
	MU_DATUM_PTR(key) = keystr;
	MU_DATUM_SIZE(key) = strlen(keystr);
	if (null)
		MU_DATUM_SIZE(key)++;

	memset(&contents, 0, sizeof contents);
	MU_DATUM_PTR(contents) = value;
	MU_DATUM_SIZE(contents) = strlen(value) + 1;
	
	rc = mu_dbm_insert(&db, key, contents, 1);
	mu_dbm_close(&db);
		if (!(rc == 0))
#line 116
			do {
#line 116
		if (env_catch(env, mf_dbfailure) == 0)
#line 116
			return ;
#line 116
		else
#line 116
			runtime_error(env,
#line 116
				                                                  "dbput: " "failed to insert data to %s: %s %s",dbname,key,value);
#line 116
	} while (0) 
#line 116
;
#line 116
;
}
}

void
#line 120
bi_dbdel(eval_environ_t env)
#line 120 "bi_db.m4"
{
#line 120
	
#line 120
char * dbname = (char *) get_arg(env, 2);
#line 120
        char * keystr = (char *) get_arg(env, 1);
#line 120
        long  null = (long ) get_arg(env, 0);
#line 120
        
#line 120
        adjust_stack(env, 3);
#line 120

#line 120
	if (prog_trace_option & BUILTIN_MASK_db)
#line 120
		prog_trace(env, "dbdel %s %s %lu",dbname, keystr, null);;
#line 120

{
	DBM_FILE db;
	DBM_DATUM key;
	
	if (mu_dbm_open(dbname, &db, MU_STREAM_RDWR, 0640, NULL))
			do {
#line 129
		if (env_catch(env, mf_dbfailure) == 0)
#line 129
			return ;
#line 129
		else
#line 129
			runtime_error(env,
#line 129
				                                                  "dbdel: " "mu_dbm_open(%s) failed: %s",dbname,mu_strerror(errno));
#line 129
	} while (0) 
#line 129
;
	memset(&key, 0, sizeof key);
	MU_DATUM_PTR(key) = keystr;
	MU_DATUM_SIZE(key) = strlen(keystr);
	if (null)
		MU_DATUM_SIZE(key)++;
	mu_dbm_delete(&db, key);
	mu_dbm_close(&db);
}
}


static void
greylist_print_item(const char *key, size_t size, const void *content)
{
	time_t timestamp = *(time_t*) content;
	size--; /* Size includes the trailing nul */
	printf("%*.*s ", size, size, key);
	format_time_str(stdout, timestamp);
	putchar('\n');
}

static int
greylist_expire_item(const void *content)
{
	time_t timestamp = *(time_t*) content;
	return greylist_format->expire_interval &&
		time(NULL) - timestamp > greylist_format->expire_interval;
}


static struct db_format greylist_format_struct = {
	"greylist",
	DEFAULT_GREYLIST_DATABASE,
	DEFAULT_EXPIRE_INTERVAL,
	greylist_print_item,
	greylist_expire_item
};

struct db_format *greylist_format = &greylist_format_struct;

static size_t greylist_seconds_left_loc
#line 170 "bi_db.m4"
;

/* greylist(key, interval)

   Returns true if the key is greylisted, false if it's OK to
   deliver mail.
 */
void
#line 177
bi_greylist(eval_environ_t env)
#line 177 "bi_db.m4"
{
#line 177
	
#line 177
char * email = (char *) get_arg(env, 1);
#line 177
        long  interval = (long ) get_arg(env, 0);
#line 177
        
#line 177
        adjust_stack(env, 2);
#line 177

#line 177
	if (prog_trace_option & BUILTIN_MASK_db)
#line 177
		prog_trace(env, "greylist %s %lu",email, interval);;
#line 177

{
	int rc;
	DBM_FILE db;
	DBM_DATUM key;
	DBM_DATUM contents;
	int readonly;
	time_t now;

	if (prog_trace_option)
		prog_trace(env, "GREYLIST %s %ld %ld", email, interval);

	rc = mu_dbm_open(greylist_format->dbname, &db, MU_STREAM_RDWR, 0600,
			 &readonly);
        	if (!(rc == 0))
			do {
#line 192
		if (env_catch(env, mf_dbfailure) == 0)
#line 192
			return ;
#line 192
		else
#line 192
			runtime_error(env,
#line 192
				                                                  "greylist: " "mu_dbm_open(%s) failed: %s",greylist_format->dbname,mu_strerror(errno));
#line 192
	} while (0) 
#line 192
;
#line 192
;
	
	memset(&key, 0, sizeof key);
	memset(&contents, 0, sizeof contents);
	MU_DATUM_PTR(key) = email;
	MU_DATUM_SIZE(key) = strlen(email)+1;

	time(&now);
	if (mu_dbm_fetch(&db, key, &contents) == 0) {
		time_t timestamp, diff;

			if (!(MU_DATUM_SIZE(contents) == sizeof timestamp))
#line 206
			do {
#line 206
		if (env_catch(env, mf_dbfailure) == 0)
#line 206
			return ;
#line 206
		else
#line 206
			runtime_error(env,
#line 206
				                                                  "greylist: " "greylist database %s has wrong data size",greylist_format->dbname);
#line 206
	} while (0) 
#line 206
;
#line 206
;
		
		timestamp = *(time_t*) MU_DATUM_PTR(contents);
		diff = now - timestamp;
	
		__DBG(20) {
			char timebuf[32];
			debug_log("%s entered greylist database on %s, "
				  "%ld seconds ago",
				  email,
				  mailfromd_timestr(timestamp, timebuf,
						    sizeof timebuf),
				  (long) diff);
		}

		if (diff < interval) {
			diff = interval - diff;

			*env_var_ref(env, greylist_seconds_left_loc) = (STKVAL) (diff);
			
			debug2(20, "%s still greylisted (for %lu sec.)",
			       email,
			       (unsigned long) diff);
			rc = 1;
		} else if (diff > greylist_format->expire_interval) {
			debug1(20, "greylist record for %s expired",
			       email);
			if (!readonly) {
				memcpy(MU_DATUM_PTR(contents),
				       &now, sizeof now);
				if (mu_dbm_insert(&db, key, contents, 1))
					mu_error("Cannot insert datum in "
						 "greylist database %s",
						 greylist_format->dbname);
			} else
				debug(20, "database opened in readonly mode: "
				      "not updating");
			rc = 1;
		} else {
			debug1(20, "%s finished greylisting period",
			       email);
			rc = 0;
		}
		mu_dbm_datum_free(&contents);
	} else if (!readonly) {
		debug1(20, "greylisting %s", email);
		*env_var_ref(env, greylist_seconds_left_loc) = (STKVAL) (interval);
		MU_DATUM_PTR(contents) = (void*)&now;
		MU_DATUM_SIZE(contents) = sizeof now;
		if (mu_dbm_insert(&db, key, contents, 1))
			mu_error("Cannot insert datum in greylist "
				 "database %s",
				 greylist_format->dbname);
		rc = 1;
	} else
		rc = 0;

	mu_dbm_close(&db);

	do {
#line 265
push(env, (STKVAL) (rc));
#line 265
return;
#line 265
} while (0);
}
}


#line 269
void
#line 269
db_init_builtin()
#line 269
{
#line 269
	#line 72 "bi_db.m4"
va_builtin_install_ex("dbmap", bi_dbmap, 0, 0, dtype_number,  3, 1,  dtype_string, dtype_string, dtype_number);
#line 80 "bi_db.m4"
va_builtin_install_ex("dbget", bi_dbget, 0, 0, dtype_string,  4, 2,  dtype_string, dtype_string, dtype_string, dtype_number);
#line 87 "bi_db.m4"
va_builtin_install_ex("dbput", bi_dbput, 0, 0, dtype_unspecified,  4, 1,  dtype_string, dtype_string, dtype_string, dtype_number);
#line 120 "bi_db.m4"
va_builtin_install_ex("dbdel", bi_dbdel, 0, 0, dtype_unspecified,  3, 1,  dtype_string, dtype_string, dtype_number);
#line 170 "bi_db.m4"
	greylist_seconds_left_loc = builtin_variable_install("greylist_seconds_left", dtype_number, VAR_VOLATILE)->off;
#line 177 "bi_db.m4"
va_builtin_install_ex("greylist", bi_greylist, 0, 0, dtype_number,  2, 0,  dtype_string, dtype_number);

#line 269 "bi_db.m4"
		
#line 269
}

#else

void db_init_builtin() {};

#endif
#line 0

#line 0

